import java.util.*;
import java.awt.*;
import javax.swing.*;
import java.applet.*;
import java.io.*;

public class JBView {	
    public static void main(String[] args) {
	Model   m = new Model();
	View    v = new View();
	Control c = new Control(m,v);
    }
}

class Model {

    ArrayList <ScreenShot> m;

    Model() {
	m = new ArrayList(); 
    }

    void addScreenShot (ScreenShot s){
	m.add(s);
    }
    
    boolean parse(String filename) {
	File file = new File(filename);
	if (!file.exists()) {
	    System.err.println("File \""+filename+"\" does not exist");
	    return false;
	}

	Scanner s = null;

	try {
	    s = new Scanner(file);
	} catch (FileNotFoundException e) {
	    System.err.println("File \""+filename+"\" does not exist");
	    return false;
	}

	s.useLocale(Locale.ENGLISH);

	while(findScreenShot(s)) {}

	return true;
    }

    boolean findScreenShot(Scanner s) {
	if (!s.hasNext("\\{")) {
	    return false;
	}
	s.next("\\{");
	
	ScreenShot sc = new ScreenShot();

	while(true) {
	    if (s.hasNext("\\}")) {
		s.next("\\}");
		addScreenShot(sc);
		return true;
	    }
	  
	    if (s.hasNext("\\{")) {
		//System.out.println("Adding a point");
		if (!findPoint(s,sc))
		    return false;
		//System.out.println("Point added");
	    } else {
		if (s.hasNext("\\[")) {
		    //System.out.println("Adding an edge");
		    if (!findArc(s,sc))
			return false;
		    //System.out.println("Edge added");
		}
		else {
		    if (s.hasNext("\\(")) {
			//System.out.println("Adding an edge");
			if (!findPolygon(s,sc))
			    return false;
			//System.out.println("Edge added");
		    }
		    else return false;
		}
	    }
	}
    }

    boolean findPoint(Scanner s, ScreenShot sc) {
	if (!s.hasNext("\\{")) {
	    System.err.println("Waiting for '{' instead of '"+s.next()+"'");
	    return false;
	}
	s.next("\\{");

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for an integer instead of '"+s.next()+"'");
	    return false;
	}
	double x = s.nextDouble();

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for an integer instead of '"+s.next()+"'");
	    return false;
	}
	double y = s.nextDouble();

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for a double instead of '"+s.next()+"'");
	    return false;
	}
        double r = s.nextDouble();

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for a double instead of '"+s.next()+"'");
	    return false;
	}
        double g = s.nextDouble();

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for a double instead of '"+s.next()+"'");
	    return false;
	}
        double b = s.nextDouble();

	if (!s.hasNext("\\}")) {
	    System.err.println("Waiting for '}' instead of '"+s.next()+"'");
	    return false;
	}
	s.next("\\}");
	
	sc.addPoint(new Point (x,y,r,g,b));

	return true;
    }

    boolean findArc(Scanner s, ScreenShot sc) {
	if (!s.hasNext("\\[")) {
	    System.err.println("Waiting for '[' instead of '"+s.next()+"'");
	    return false;
	}
	s.next("\\[");

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for an integer instead of '"+s.next()+"'");
	    return false;
	}
	double x1 = s.nextDouble();

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for an integer instead of '"+s.next()+"'");
	    return false;
	}
	double y1 = s.nextDouble();

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for an integer instead of '"+s.next()+"'");
	    return false;
	}
	double x2 = s.nextDouble();

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for an integer instead of '"+s.next()+"'");
	    return false;
	}
	double y2 = s.nextDouble();

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for a double instead of '"+s.next()+"'");
	    return false;
	}
        double r = s.nextDouble();

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for a double instead of '"+s.next()+"'");
	    return false;
	}
        double g = s.nextDouble();

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for a double instead of '"+s.next()+"'");
	    return false;
	}
        double b = s.nextDouble();

	if (!s.hasNext("\\]")) {
	    System.err.println("Waiting for ']' instead of '"+s.next()+"'");
	    return false;
	}
	s.next("\\]");
	
	sc.addArc(new Arc (x1,y1,x2,y2,r,g,b));

	return true;
    }

    boolean findPolygon(Scanner s, ScreenShot sc) {

	if (!s.hasNext("\\(")) {
	    System.err.println("Waiting for '(' instead of '"+s.next()+"'");
	    return false;
	}
	s.next("\\(");
	
	if (!s.hasNextInt()) {
	    System.err.println("Waiting for an integer instead of '"+s.next()+"'");
	    return false;
	}
	int nbPoints = s.nextInt();
	//System.out.println("coucou "+nbPoints);

	Polygone p = new Polygone();

	for(int i=0;i<nbPoints;i++) {
	    
	    if (!s.hasNextDouble()) {
		System.err.println("Waiting for an integer instead of '"+s.next()+"'");
		return false;
	    }
	    double x = s.nextDouble();

	    if (!s.hasNextDouble()) {
		System.err.println("Waiting for an integer instead of '"+s.next()+"'");
		return false;
	    }
	    double y = s.nextDouble();

	    p.addPoint(x,y);
	}


	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for a double instead of '"+s.next()+"'");
	    return false;
	}
        double r = s.nextDouble();

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for a double instead of '"+s.next()+"'");
	    return false;
	}
        double g = s.nextDouble();

	if (!s.hasNextDouble()) {
	    System.err.println("Waiting for a double instead of '"+s.next()+"'");
	    return false;
	}
        double b = s.nextDouble();

	if (!s.hasNext("\\)")) {
	    System.err.println("Waiting for ')' instead of '"+s.next()+"'");
	    return false;
	}
	s.next("\\)");
	
	p.setColor(r,g,b);

	p.finalizePolygon();

	sc.addPolygone(p);

	return true;
    }
    

}

class ScreenShot {

    ArrayList <Point> pts;
    ArrayList <Arc> arcs;
    ArrayList <Polygone> polygons;

    ScreenShot(){
	pts = new ArrayList();
	arcs = new ArrayList();
	polygons = new ArrayList();
    }

    void addPoint (Point p){
	pts.add(p);
    }

    void addArc (Arc a){
	arcs.add(a);
    }

    void addPolygone (Polygone p){
	polygons.add(p);
    }

}

class Polygone {

    class Pt implements Comparable {
	public double x;
	public double y;
	public double theta;

	Pt(double xx, double yy) {
	    theta = 0.0;
	    x     = xx;
	    y     = yy;
	}

	public int compareTo(Object o) {
	    return (int)(1000*(((Pt)o).theta - theta));
	}

	public void computeTheta() {
	    if ((x > 0) && (y >= 0)) { theta = Math.atan(y/x); return ; }
	    if ((x > 0) && (y < 0))  { theta = Math.atan(y/x) + 2.0*Math.PI; return ; }
	    if  (x < 0)              { theta = Math.atan(y/x) + Math.PI; return ; }
	    if ((x == 0) && (y > 0)) { theta = Math.PI / 2.0; return ; }
	    if ((x == 0) && (y < 0)) { theta = 3.0*Math.PI / 2.0; return ; }
	}
    }

    ArrayList <Pt> ps;
    int r;
    int g;
    int b;
    double cx;
    double cy;

    Polygone() {
	ps = new ArrayList();
    }

    void setColor(double rr, double gg, double bb) {
	r=(int)((rr<=1.0?rr:1.0)*255);
	g=(int)((gg<=1.0?gg:1.0)*255);
	b=(int)((bb<=1.0?bb:1.0)*255);
    }

    void addPoint(double x, double y) {
	ps.add(new Pt(x,y));
    }

    public void paintMe(Graphics gr, double ratio) {
	gr.setColor(new Color(r,g,b));
	Graphics2D g2 = (Graphics2D) gr;

	Polygon p = new Polygon();
	for(int i=0;i<ps.size();i++) {
	    Pt pt = ps.get(i);
	    p.addPoint((int)(6*(cx+ratio*pt.x)+3),(int)(6*(cy+ratio*pt.y)+3));
	}
	g2.fill(p);
    }

    void finalizePolygon() {
	cx=0.0;
	cy=0.0;
	for(int i=0; i<ps.size(); i++) {
	    Pt p=ps.get(i);
	    cx += p.x;
	    cy += p.y;
	}
	cx = cx / ps.size();
	cy = cy / ps.size();
	for(int i=0; i<ps.size(); i++) {
	    Pt p=ps.get(i);
	    p.x-=cx;
	    p.y-=cy;
	    p.computeTheta();
	}
	Collections.sort(ps);

    }
}

class Point {

    double x;
    double y;
    int r;
    int g;
    int b;

    Point(double xx, double yy, double rr, double gg, double bb){
	x=xx;
	y=yy;
	r=(int)((rr<=1.0?rr:1.0)*255);
	g=(int)((gg<=1.0?gg:1.0)*255);
	b=(int)((bb<=1.0?bb:1.0)*255);
    }

    public void paintCircle(Graphics gr,int radius) {
 	gr.setColor(new Color(200,200,200));
	gr.drawOval((int)(6*(x-radius)+3),
		    (int)(6*(y-radius)+3),12*radius,12*radius);
    }

    public void paintMeAmorph(Graphics gr) {
	gr.setColor(new Color(r,g,b));
	gr.fillOval((int)(6*x-1),
		    (int)(6*y-1),8,8);
    }

    public void paintMeAC(Graphics gr) {
	gr.setColor(new Color(r,g,b));
	gr.fillRect((int)(6*x),(int)(6*y),6,6);
    }

}

class Arc {

    double x1;
    double y1;
    double x2;
    double y2;
    int r;
    int g;
    int b;

    Arc(double xx1, double yy1, double xx2, double yy2, double rr, double gg, double bb) {
	x1=xx1;
	y1=yy1;
	x2=xx2;
	y2=yy2;
	r=(int)(rr*255);
	g=(int)(gg*255);
	b=(int)(bb*255);
    }

    public void paintMe(Graphics gr) {
	gr.setColor(new Color(r,g,b));
	gr.drawLine((int)(6*x1+3),(int)(6*y1+3),(int)(6*x2+3),(int)(6*y2+3));
    }

}



class View extends JFrame {

    static final int MODE_AC    = 0;
    static final int MODE_PROXY = 1;
    static final int MODE_CHAIN = 2;
    static final int NBMODE     = 3;

    public JButton    vizuModeButton;
    public JButton    delayButton;
    public JButton    radiusButton;
    public JButton    fplayButton;
    public JButton    bplayButton;
    public JButton    pauseButton;
    public JButton    stopButton;
    public JButton    fstepButton;
    public JButton    bstepButton;
    public JButton    loadButton;
    public JTextField txtField;
    public JTextField delayField;
    public JTextField radiusField;
    public JCheckBox  neighborCheck;
    public JLabel     modeLabel;
    public VBPanel    imagePanel;


    View() {
	// Create the main window
	super("JBView");
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	setPreferredSize(new Dimension(700,750));
	setResizable(false);
	
	// Elements of the GUI
	imagePanel = new VBPanel();

	delayField = new JTextField();
	delayField.setText("200");
	delayField.setPreferredSize(new Dimension (100,25));
	delayField.setHorizontalAlignment(JTextField.RIGHT);

	delayButton = new JButton();
	delayButton.setText("Delay");
	delayButton.setPreferredSize(new Dimension (100,25));

	fplayButton = new JButton();
	fplayButton.setText("Play");
	fplayButton.setPreferredSize(new Dimension (100,25));

	bplayButton = new JButton();
	bplayButton.setText("BPlay");
	bplayButton.setPreferredSize(new Dimension (100,25));

	pauseButton = new JButton();
	pauseButton.setText("Pause");
	pauseButton.setPreferredSize(new Dimension (100,25));

	stopButton  = new JButton();
	stopButton.setText("Stop");
	stopButton.setPreferredSize(new Dimension (100,25));

	fstepButton = new JButton();
	fstepButton.setText("Step");
	fstepButton.setPreferredSize(new Dimension (100,25));

	bstepButton = new JButton();
	bstepButton.setText("BStep");
	bstepButton.setPreferredSize(new Dimension (100,25));

	loadButton  = new JButton();
	loadButton.setText("Load");
	loadButton.setPreferredSize(new Dimension (100,25));

	txtField = new JTextField();
	txtField.setPreferredSize(new Dimension (300,25));
	txtField.setHorizontalAlignment(JTextField.RIGHT);

	vizuModeButton = new JButton();
	vizuModeButton.setText("Change");
	vizuModeButton.setPreferredSize(new Dimension (100,25));

	modeLabel = new JLabel();
	modeLabel.setHorizontalAlignment(JLabel.LEFT);
	modeLabel.setText("Chain Mode");

	radiusField = new JTextField();
	radiusField.setText("90"); imagePanel.radius_ = 90;
	radiusField.setPreferredSize(new Dimension (100,25));
	radiusField.setHorizontalAlignment(JTextField.RIGHT);

	radiusButton = new JButton();
	radiusButton.setText("Ratio");
	radiusButton.setPreferredSize(new Dimension (100,25));

	neighborCheck = new JCheckBox();
	neighborCheck.setText("");
	neighborCheck.setSelected(true); imagePanel.showRadius_ = true;
	neighborCheck.setPreferredSize(new Dimension (100,25));
	neighborCheck.setHorizontalAlignment(JTextField.RIGHT);
	neighborCheck.setEnabled(false);

	switchMode(View.MODE_CHAIN);

	// Building the GUI
	GridBagLayout layout = new GridBagLayout();
	setLayout(layout);
	
	GridBagConstraints c = new GridBagConstraints();

	c.gridx = 0; c.gridy = 0;
	add(delayField,c);
	c.gridx = 1; c.gridy = 0;
	add(delayButton,c);
	c.gridx = 2; c.gridy = 0;
	c.gridwidth = 3;
	add(txtField,c);
	c.gridx = 5; c.gridy = 0;
	c.gridwidth = 1;
	add(loadButton,c);

	c.gridwidth = 1;
	c.gridx = 0; c.gridy = 1;
	add(vizuModeButton,c);
	c.gridwidth = 2;
	c.gridx = 1; c.gridy = 1;
	add(modeLabel,c);
	c.gridwidth = 1;
	c.gridx = 3; c.gridy = 1;
	add(neighborCheck,c);
	c.gridx = 4; c.gridy = 1;
	add(radiusField,c);
	c.gridx = 5; c.gridy = 1;
	add(radiusButton,c);

	c.gridx = 0; c.gridy = 3;
	JSeparator sep = new JSeparator();
	sep.setPreferredSize(new Dimension(0,20));
	add(sep, c);

	c.gridwidth = 1;
	c.gridx = 0; c.gridy = 4;
	add(bstepButton,c);
	c.gridx = 1; c.gridy = 4;
	add(bplayButton,c);
	c.gridx = 2; c.gridy = 4;
	add(pauseButton,c);
	c.gridx = 3; c.gridy = 4;
	add(fplayButton,c);
	c.gridx = 4; c.gridy = 4;
	add(fstepButton,c);
	c.gridx = 5; c.gridy = 4;
	add(stopButton,c);

	c.gridx = 0; c.gridy = 5;
	c.gridwidth = 6;
	add(imagePanel,c);

	// Sizing and displaying the window
	pack();
	setVisible(true);
    }
    
    // Accessing the picture
    VBPanel getImagePanel() {
	return imagePanel;
    }
    
    // Accessing the button
    JButton getMoveButton() {
	return pauseButton;
    }

    void switchMode() {
	switchMode((imagePanel.mode_+1)%NBMODE);
    }

    void switchMode(int MODE) {
	imagePanel.mode_ = MODE;
	switch (MODE) {
	case MODE_PROXY:
	    modeLabel.setText("Proximal Mode");
	    radiusButton.setText("Radius");
	    radiusButton.setEnabled(true);
	    radiusField.setEnabled(true);
	    neighborCheck.setEnabled(true);
	    break;
	case MODE_CHAIN:
	    modeLabel.setText("Chain Mode");
	    radiusButton.setText("Ratio");
	    radiusButton.setEnabled(true);
	    radiusField.setEnabled(true);
	    neighborCheck.setEnabled(false);
	    break;
	case MODE_AC:
	    modeLabel.setText("Cellular Automata Mode");
	    radiusButton.setText("---");
	    radiusButton.setEnabled(false);
	    radiusField.setEnabled(false);
	    neighborCheck.setEnabled(false);
	    break;
	}
    }

    
}

class VBPanel extends JPanel {
    
    static final Color DEFAULT_BKG = new Color(255,255,255) ;

    int size_x = 600 ;
    int size_y = 600 ;

    public int radius_;
    public boolean showRadius_;
    public int mode_;
    
    ScreenShot sc;

    VBPanel () {
	super();
	setBorder(BorderFactory.createLineBorder(Color.black));
	setPreferredSize(new Dimension(size_x,size_y));
	setBackground(DEFAULT_BKG);
	sc=null;
    }

    void setScreenShot(ScreenShot mm) {
	sc = mm;
    }

    // Method called when the component is updated (eg, with repaint)
    // Here, all sprites are painted
    public void paintComponent(Graphics g) {
	super.paintComponent(g);
	if(sc!=null) {
	    switch (mode_) {
	    case View.MODE_AC:
		for(int i=0;i<sc.pts.size();i++) {
		    Point p = sc.pts.get(i);
		    p.paintMeAC(g);
		}
		break;
	    case View.MODE_PROXY:
		if (showRadius_)
		    for(int i=0;i<sc.pts.size();i++) {
			Point p = sc.pts.get(i);
			p.paintCircle(g,radius_);
		    }
		for(int i=0;i<sc.pts.size();i++) {
		    Point p = sc.pts.get(i);
		    p.paintMeAmorph(g);
		}
		break;
	    case View.MODE_CHAIN:
		for(int i=0;i<sc.polygons.size();i++) {
		    Polygone p = sc.polygons.get(i);
		    p.paintMe(g,radius_>=100.0?1.0:(radius_/100.0));
		}
		for(int i=0;i<sc.arcs.size();i++) {
		    Arc a = sc.arcs.get(i);
		    a.paintMe(g);
		}
		for(int i=0;i<sc.pts.size();i++) {
		    Point p = sc.pts.get(i);
		    p.paintMeAmorph(g);
		}
		break;
	    }
	}
    }   
}

class Control implements Runnable {
    Model   m_;
    View    v_;
    String  filename_;
    boolean loaded_;
    boolean pause_;
    boolean running_;
    Thread  thread_;

    int currentSc_;
    int maxSc_;
    int delay_;
    int dir_;
    
    Control(Model m, View v) {
	v_ = v;
	m_ = m;
	filename_ = "/tmp/toto";
	loaded_ = false;
	pause_ = false;
	running_ = false;
	delay_=200;
	dir_=1;
	init();
    }

    void init() {
	
	v_.txtField.setText(filename_);

	v_.delayField.setText(""+delay_);

	v_.loadButton.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) {
		    load(v_.txtField.getText());
		}
	    });

	v_.delayButton.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) {
		    delay_ = Integer.parseInt(v_.delayField.getText());
		}
	    });

	v_.fplayButton.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) {
		    start(1);
		}
	    });

	v_.bplayButton.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) {
		    start(maxSc_-1);
		}
	    });

	v_.fstepButton.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) {
		    int d=dir_;
		    dir_ = 1;
		    step();
		    dir_ = d;
		}
	    });

	v_.bstepButton.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) {
		    int d=dir_;
		    dir_ = maxSc_-1;
		    step();
		    dir_ = d;
		}
	    });

	v_.pauseButton.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) {
		    if (pause_) {
		    	resume();
		    } else
		    	suspend();
		}
	    });

	v_.stopButton.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) {
		    stop();
		}
	    });

	v_.neighborCheck.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) {
		     v_.imagePanel.showRadius_ = !v_.imagePanel.showRadius_;
		     v_.repaint();
		}
	    });

	v_.radiusButton.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) {
		    v_.imagePanel.radius_ = Integer.parseInt(v_.radiusField.getText());
		    v_.repaint();
		}
	    });

	v_.vizuModeButton.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(java.awt.event.ActionEvent evt) {
		    v_.switchMode();
		    v_.repaint();
		}
	    });

	v_.repaint();
    }

    void load(String fn) {
	boolean t = running_ && !pause_;
	stop();
	filename_ = fn;
	System.out.println("Chargement du fichier: "+filename_);
	if (t) suspend();
	if(loaded_) {
	    m_.m.clear();
	}
	loaded_ = m_.parse(filename_);
	if(loaded_) {
	    currentSc_ = 0;
	    maxSc_ = m_.m.size();
	    v_.imagePanel.setScreenShot(m_.m.get(currentSc_));
	    v_.repaint();
	}
	if (t) start(dir_);
    }

    void start(int d) {
	dir_ = d;
	if(loaded_ && !running_) {
	    currentSc_ = -1;
	    running_ = true;
	    pause_ = false;
	    thread_ = new Thread(this);
	    thread_.start();
	}
    }

    void stop() {
	if (loaded_ && running_) {
	    running_ = false;
	    pause_ = false;
	    thread_.interrupt();
	}
    }

    void suspend() {
	if (loaded_ && running_) {
	    pause_ = true;
	    thread_.interrupt();
	}
    }

    synchronized void resume() {
	if (loaded_ && running_) {
	    pause_ = false;
	    notify();
	}
    }

    synchronized boolean waitIfPaused() {
	while(pause_) {
	    try {
		wait();
	    } catch (InterruptedException ie) {
		return true;
	    }
	}
	return false;
    }

    void step() {
	if (loaded_) {
	    currentSc_ = (currentSc_+dir_)%maxSc_;
	    v_.imagePanel.setScreenShot(m_.m.get(currentSc_));
	    v_.repaint();
	}
    }

    public void run() {
	while(running_) {

	    if (waitIfPaused()) continue;

	    try {
		Thread.sleep(delay_);
	    } catch (InterruptedException ie) {
		continue;
	    }
	    // Faire ce qu'on veut faire...
	    step();
	}
	// Faire ce qu'on veut faire quand ca tourne plus
    }

}


